/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20100528
 *
 * Disassembly of SSDT3.dat, Tue Oct 18 09:41:06 2011
 *
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x0000078F (1935)
 *     Revision         0x01
 *     Checksum         0x3A
 *     OEM ID           "HP    "
 *     OEM Table ID     "AMDSGTBL"
 *     OEM Revision     0x00000001 (1)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20060912 (537266450)
 */
DefinitionBlock ("SSDT3.aml", "SSDT", 1, "HP    ", "AMDSGTBL", 0x00000001)
{
    External (G28I)
    External (MX28)
    External (G55E)
    External (G55O)
    External (G45E)
    External (G45O)
    External (G44E)
    External (G44O)
    External (VRMS, MethodObj)    // 0 Arguments
    External (VRMB, MethodObj)    // 1 Arguments
    External (FMOD)
    External (SGME)
    External (\_SB_.ALIB, MethodObj)    // 2 Arguments
    External (\_SB_.PCI0.GFX0, DeviceObj)
    External (\_SB_.PCI0.PEGP._ADR)
    External (\_SB_.PCI0.GFX0.SVID, IntObj)
    External (\_SB_.PCI0.PEGP.XPR2)
    External (\_SB_.PCI0.PEGP.XPRT, MethodObj)    // 0 Arguments
    External (\_SB_.PCI0.PEGP.XPDL, IntObj)
    External (\_SB_.PCI0.PEGP.XPRD, IntObj)
    External (\_SB_.PCI0.PEGP.PSDC)
    External (\_SB_.PCI0.PEGP.DGFX, DeviceObj)

    Scope (\_SB.PCI0.GFX0)
    {
        Method (ATPX, 2, Serialized)
        {
            Name (_T_0, Zero)
            Store (Arg0, _T_0)
            If (LEqual (_T_0, 0x00))
            {
                Store (PX00 (), Local0)
            }
            Else
            {
                If (LEqual (_T_0, 0x01))
                {
                    Store (PX01 (), Local0)
                }
                Else
                {
                    If (LEqual (_T_0, 0x02))
                    {
                        PX02 (Arg1)
                    }
                    Else
                    {
                        Store (Buffer (0x0100)
                            {
                                0x00, 0x00
                            }, Local0)
                    }
                }
            }

            Return (Local0)
        }

        Method (PX00, 0, Serialized)
        {
            Store (Buffer (0x0100) {}, Local0)
            CreateWordField (Local0, 0x00, SIZE)
            CreateWordField (Local0, 0x02, IVER)
            CreateDWordField (Local0, 0x04, SFBV)
            Store (0x08, SIZE)
            Store (0x01, IVER)
            If (And (SGME, 0x0F))
            {
                If (LEqual (And (SGME, 0x0F), 0x01))
                {
                    Store (0x03, SFBV)
                }

                If (LEqual (And (SGME, 0x0F), 0x02))
                {
                    If (LEqual (FMOD, 0x00))
                    {
                        Store (0x01, SFBV)
                    }
                    Else
                    {
                        Store (0x03, SFBV)
                    }
                }
            }
            Else
            {
                Store (0x00, SFBV)
            }

            Return (Local0)
        }

        Method (PX01, 0, Serialized)
        {
            Store (Buffer (0x0100) {}, Local0)
            CreateWordField (Local0, 0x00, SIZE)
            CreateDWordField (Local0, 0x02, VFMK)
            CreateDWordField (Local0, 0x06, FLAG)
            Store (0x0A, SIZE)
            Store (0xFF, VFMK)
            Store (0x80, FLAG)
            Return (Local0)
        }

        Method (PX02, 1, Serialized)
        {
            CreateWordField (Arg0, 0x00, SIZI)
            CreateByteField (Arg0, 0x02, PWST)
            And (PWST, 0x01, PWST)
            If (PWST)
            {
                \_SB.PCI0.PEGP.DGFX._ON ()
            }
            Else
            {
                \_SB.PCI0.PEGP.DGFX._OFF ()
            }
        }

        OperationRegion (REVD, SystemMemory, VRMB (VRMS ()), Field (REVD, AnyAcc, NoLock, Preserve)
            {
                SROM,   32, 
                VROM,   512000
            })
        Name (TVGA, Buffer (0xFA00)
        {
            0x00
        })
        Method (ATRM, 2, Serialized)
        {
            Add (Arg0, Arg1, Local0)
            If (LLessEqual (Local0, SROM))
            {
                Multiply (Arg1, 0x08, Local1)
                Multiply (Arg0, 0x08, Local2)
                Store (VROM, TVGA)
                CreateField (TVGA, Local2, Local1, TEMP)
                Name (RETB, Buffer (Arg1) {})
                Store (TEMP, RETB)
                Return (RETB)
            }
            Else
            {
                If (LLess (Arg0, SROM))
                {
                    Subtract (SROM, Arg0, Local3)
                    Multiply (Local3, 0x08, Local1)
                    Multiply (Arg0, 0x08, Local2)
                    Store (VROM, TVGA)
                    CreateField (TVGA, Local2, Local1, TEM)
                    Name (RETC, Buffer (Local3) {})
                    Store (TEM, RETC)
                    Return (RETC)
                }
                Else
                {
                    Name (RETD, Buffer (0x01) {})
                    Return (RETD)
                }
            }
        }
    }

    Scope (\_SB.PCI0.PEGP.DGFX)
    {
        Name (PXID, 0x00030000)
        Name (DSID, 0xFFFFFFFF)
        Name (DGPM, 0x03)
        OperationRegion (PCFG, PCI_Config, 0x00, 0x6C)
        Field (PCFG, DWordAcc, NoLock, Preserve)
        {
            DVID,   32, 
                    Offset (0x2C), 
            SVID,   32, 
                    Offset (0x4C), 
            SMID,   32, 
                    Offset (0x68), 
            PMCL,   8
        }

        Name (ALDB, Buffer (0x05) {})
        CreateWordField (ALDB, 0x00, SZZE)
        CreateField (ALDB, 0x10, 0x03, FUCC)
        CreateField (ALDB, 0x13, 0x05, DEVV)
        CreateByteField (ALDB, 0x03, BUSS)
        CreateByteField (ALDB, 0x04, HPST)
        Name (PHDB, Buffer (0x04) {})
        CreateWordField (PHDB, 0x00, BLEN)
        CreateByteField (PHDB, 0x02, RESS)
        CreateByteField (PHDB, 0x03, HPSS)
        Method (_ON, 0, Serialized)
        {
            Name (HPOK, 0x00)
            Store (0x05, SZZE)
            Store (0x00, BUSS)
            Store (0x00, FUCC)
            Store (Zero, G44O)
            Store (Zero, G44E)
            Store (Zero, G45O)
            Store (Zero, G45E)
            Sleep (0x0A)
            Store (One, G45O)
            Store (Zero, G45E)
            Sleep (0x0A)
            If (0x00)
            {
                Store (One, G55O)
                Store (Zero, G55E)
            }

            Sleep (0x0A)
            Store (One, MX28)
            While (LEqual (G28I, 0x00)) {}
            Store (One, G44O)
            Store (Zero, G44E)
            Store (0x00, HPOK)
            Sleep (0x64)
            Sleep (0x64)
            Store (0x03, DEVV)
            Store (0x01, HPST)
            Store (\_SB.ALIB (0x06, ALDB), PHDB)
            Sleep (0x14)
            Store (0x00, Local2)
            While (LLess (Local2, 0x0F))
            {
                Store (One, \_SB.PCI0.PEGP.PSDC)
                Store (0x01, Local4)
                Store (0xC8, Local5)
                While (LAnd (Local4, Local5))
                {
                    Store (\_SB.PCI0.PEGP.XPRD, 0xA5)
                    Local0
                    And (Local0, 0x7F, Local0)
                    If (LAnd (LGreaterEqual (Local0, 0x10), LNotEqual (Local0, 0x7F)))
                    {
                        Store (0x00, Local4)
                    }
                    Else
                    {
                        Sleep (0x05)
                        Decrement (Local5)
                    }
                }

                If (LNot (Local4))
                {
                    Store (\_SB.PCI0.PEGP.XPDL, Local5)
                    If (Local5)
                    {
                        \_SB.PCI0.PEGP.XPRT ()
                        Sleep (0x05)
                        Increment (Local2)
                    }
                    Else
                    {
                        If (LEqual (\_SB.PCI0.PEGP.XPR2, Ones))
                        {
                            Store (0x01, HPOK)
                            Store (0x10, Local2)
                        }
                        Else
                        {
                            Store (0x00, HPOK)
                            Store (0x10, Local2)
                        }
                    }
                }
                Else
                {
                    Store (0x10, Local2)
                }
            }

            If (LNot (HPOK))
            {
                Store (\_SB.PCI0.PEGP.DGFX.DVID, Local1)
                Sleep (0x0A)
                Store (0x01, Local4)
                Store (0x05, Local5)
                While (LAnd (Local4, Local5))
                {
                    Store (\_SB.PCI0.PEGP.XPRD, 0xA5)
                    Local0
                    And (Local0, 0x7F, Local0)
                    If (LLessEqual (Local0, 0x04))
                    {
                        Store (0x00, Local4)
                    }
                    Else
                    {
                        Store (\_SB.PCI0.PEGP.DGFX.DVID, Local1)
                        Sleep (0x05)
                        Decrement (Local5)
                    }
                }

                Store (0x03, DEVV)
                Store (0x00, HPST)
                \_SB.ALIB (0x06, ALDB)
            }

            If (LAnd (LEqual (HPOK, 0x01), LNotEqual (\_SB.PCI0.PEGP.DGFX.DVID, 0xFFFFFFFF)))
            {
                Store (\_SB.PCI0.GFX0.SVID, Local1)
                Store (Local1, \_SB.PCI0.PEGP.DGFX.SMID)
                Store (\_SB.PCI0.PEGP.DGFX.PMCL, Local0)
                Or (Local0, \_SB.PCI0.PEGP.DGFX.DGPM, Local0)
                Store (Local0, \_SB.PCI0.PEGP.DGFX.PMCL)
                Sleep (0x0A)
            }

            Notify (\_SB.PCI0.PEGP, 0x00)
            Return (0x01)
        }

        Method (_OFF, 0, Serialized)
        {
            Store (0x05, SZZE)
            Store (0x00, BUSS)
            Store (0x00, FUCC)
            If (LEqual (\_SB.PCI0.PEGP.DGFX.PXID, \_SB.PCI0.PEGP._ADR))
            {
                Store (\_SB.PCI0.PEGP.DGFX.SVID, Local1)
            }

            If (LNotEqual (Local1, 0xFFFFFFFF))
            {
                Store (Local1, \_SB.PCI0.PEGP.DGFX.DSID)
            }

            Store (Zero, G44O)
            Store (Zero, G44E)
            If (0x00)
            {
                Store (Zero, G55O)
                Store (Zero, G55E)
            }

            Sleep (0x0A)
            Store (Zero, G45O)
            Store (Zero, G45E)
            Store (One, \_SB.PCI0.PEGP.PSDC)
            Store (\_SB.PCI0.PEGP.DGFX.DVID, Local1)
            Sleep (0x0A)
            Store (0x01, Local4)
            Store (0x05, Local5)
            While (LAnd (Local4, Local5))
            {
                Store (\_SB.PCI0.PEGP.XPRD, 0xA5)
                Local0
                And (Local0, 0x7F, Local0)
                If (LLessEqual (Local0, 0x04))
                {
                    Store (0x00, Local4)
                }
                Else
                {
                    Store (\_SB.PCI0.PEGP.DGFX.DVID, Local1)
                    Sleep (0x05)
                    Decrement (Local5)
                }
            }

            Store (0x03, DEVV)
            Store (0x00, HPST)
            Store (\_SB.ALIB (0x06, ALDB), PHDB)
            Notify (\_SB.PCI0.PEGP, 0x00)
            Return (0x01)
        }
    }
}

