/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20100528
 *
 * Disassembly of SSDT4.dat, Tue Oct 18 09:41:06 2011
 *
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x0000032F (815)
 *     Revision         0x01
 *     Checksum         0x1D
 *     OEM ID           "HP    "
 *     OEM Table ID     "HPZPODDT"
 *     OEM Revision     0x00000001 (1)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20060912 (537266450)
 */
DefinitionBlock ("SSDT4.aml", "SSDT", 1, "HP    ", "HPZPODDT", 0x00000001)
{
    External (GE16, IntObj)
    External (GT16, IntObj)
    External (E177)
    External (O177)
    External (E170)
    External (O170)
    External (\WCOS)
    External (\_SB_.PCI0.SATA, DeviceObj)
    External (\_SB_.PCI0.SATA.PTI1)
    External (\_SB_.PCI0.SATA.WTEN)
    External (\_SB_.PCI0.SATA.SP1D)
    External (\_SB_.PCI0.SATA.DVID)

    Scope (\_SB.PCI0.SATA)
    {
        Device (ODDZ)
        {
            Name (_ADR, 0x01)
            Name (ODPS, 0x00)
            Name (ZPOD, 0x01)
            Method (_STA, 0, NotSerialized)
            {
                If (LLessEqual (\WCOS, 0x06))
                {
                    Return (0x00)
                }
                Else
                {
                    Return (0x0F)
                }
            }

            Method (_PS0, 0, NotSerialized)
            {
                If (LNotEqual (\_SB.PCI0.SATA.DVID, 0x7800))
                {
                    Store (Zero, \_SB.PCI0.SATA.SP1D)
                    Store (One, \_SB.PCI0.SATA.WTEN)
                    Store (One, \_SB.PCI0.SATA.PTI1)
                    Store (Zero, \_SB.PCI0.SATA.WTEN)
                    Sleep (0x28)
                    If (0x00)
                    {
                        Store (Zero, O170)
                        Store (Zero, E170)
                    }

                    Store (One, O177)
                    Store (Zero, E177)
                    Sleep (0x28)
                }

                Store (0x00, ODPS)
            }

            Method (_PS3, 0, NotSerialized)
            {
                If (LNotEqual (\_SB.PCI0.SATA.DVID, 0x7800))
                {
                    Sleep (0x28)
                    If (0x00)
                    {
                        Store (Zero, O170)
                        Store (Zero, E170)
                    }

                    Store (Zero, O177)
                    Store (Zero, E177)
                    Sleep (0x28)
                    Store (One, \_SB.PCI0.SATA.SP1D)
                    Store (One, \_SB.PCI0.SATA.WTEN)
                    Store (Zero, \_SB.PCI0.SATA.PTI1)
                    Store (Zero, \_SB.PCI0.SATA.WTEN)
                }

                Store (0x03, ODPS)
            }

            Method (_PSC, 0, NotSerialized)
            {
                Return (ODPS)
            }

            Device (ODD)
            {
                Name (_ADR, 0x00)
                Method (_RMV, 0, NotSerialized)
                {
                    Return (0x01)
                }

                Method (_EJX, 1, NotSerialized)
                {
                    Sleep (0x28)
                    If (0x00)
                    {
                        Store (Zero, O170)
                        Store (Zero, E170)
                    }

                    Store (Zero, O177)
                    Store (Zero, E177)
                    Sleep (0x28)
                }
            }
        }
    }

    Scope (\_GPE)
    {
        Method (_L10, 0, NotSerialized)
        {
            If (GT16)
            {
                Sleep (0x14)
                If (GE16)
                {
                    Store ("GEVENT12# input value is High", Debug)
                    Store (Zero, GT16)
                    If (LNotEqual (\_SB.PCI0.SATA.DVID, 0x7800))
                    {
                        Store ("Notify ODD for Power State Change", Debug)
                        Notify (\_SB.PCI0.SATA.ODDZ, 0x80)
                    }
                }
            }
            Else
            {
                Sleep (0x14)
                If (LNot (GE16))
                {
                    Store ("GEVENT16# input value is Low", Debug)
                    Store (One, GT16)
                    If (LNotEqual (\_SB.PCI0.SATA.DVID, 0x7800))
                    {
                        Store ("Notify ODD for Power State Change", Debug)
                        Notify (\_SB.PCI0.SATA.ODDZ, 0x80)
                    }
                }
            }
        }
    }
}

